# Drupal 8 Commerce
services:
  # What to call the service hosting the site.
  php:

    # Use PHP 7.2 with Apache
    image: tugboatqa/php:7.2-apache

    # Set this as the default service. This does a few things
    #   1. Clones the git repository into the service container
    #   2. Exposes port 80 to the Tugboat HTTP proxy
    #   3. Routes requests to the preview URL to this service
    default: true
    depends: mysql

    # A set of commands to run while building this service
    commands:

      build:
        - wget -O/dev/null <?php print $status_endpoint; ?>/<?php print SIMPLYTEST_STATUS_DOWNLOAD;?>

        - composer global require szeidler/composer-patches-cli:~1.0
        - cd "${DOCROOT}" && composer require cweagans/composer-patches:~1.0 --no-update
        # Running composer install.
        - cd "${TUGBOAT_ROOT}"/commerce && composer install --no-ansi --no-dev

<?php if (!empty($project) and ($project_type == 'Module' or $project_type == 'Theme')): ?>
        # Running the project.
        - cd "${TUGBOAT_ROOT}"/commerce && composer require drupal/<?php print $project; ?>:<?php print $project_version; ?> --no-update
<?php endif; ?>
<?php foreach ($additionals as $additional) { ?>
<?php if (!empty($additional)): ?>
        # Additional.
        - cd "${TUGBOAT_ROOT}"/commerce && composer require drupal/<?php print $additional; ?> --no-update
<?php endif; ?>
<?php } ?>
        # Run update for installed projects.
        - cd "${TUGBOAT_ROOT}"/commerce && composer update --no-ansi --no-dev
        - wget -O/dev/null <?php print $status_endpoint; ?>/<?php print SIMPLYTEST_STATUS_PATCHING;?>

<?php if (!empty($patches)): ?>

        # Apply patches.
        - cd "${DOCROOT}" && composer patch-enable --file='patches.json'
  <?php foreach ($patches as $patch) { if (!empty($patch)) {?>

        - cd "${DOCROOT}" && composer patch-add drupal/<?php
    if ($project !== 'drupal') {
      print $project;
    } else {
      print 'core';
    } ?> "STM patch <?php print time(); ?>" "<?php print $patch; ?>"

  <?php } } ?>

<?php endif; ?>

        - wget -O/dev/null <?php print $status_endpoint; ?>/<?php print SIMPLYTEST_STATUS_INSTALLING;?>
<?php if ($perform_install): ?>
        # Install commerce.
        #- cd "${TUGBOAT_ROOT}/commerce" && php scripts/quickstart
        - cd "${DOCROOT}" && echo 'if (PHP_SAPI === "cli"){ ini_set("memory_limit", "-1"); }' >> sites/default/settings.php
        - drush -r "${DOCROOT}" si demo_commerce --account-name=admin --account-pass=admin -y
        - cd "${DOCROOT}" && chmod -R 777 sites/default/files
<?php   foreach ($additionals as $additional) { ?>
<?php       if (!empty($additional)): ?>
        - drush -r "${DOCROOT}" en <?php print $additional; ?> -y
<?php       endif; ?>
<?php   } ?>
<?php endif; ?>
        - wget -O/dev/null <?php print $status_endpoint; ?>/<?php print SIMPLYTEST_STATUS_FINALIZE;?>

  # What to call the service hosting MySQL. This name also acts as the
  # hostname to access the service by from the php service.
  mysql:
    # Use the latest available 5.x version of MySQL
    image: tugboatqa/mysql:5
