<?php

/**
 * Simply formatter to show status label or code.
 */
class simplytest_tugboat_field_status extends views_handler_field_numeric {

  public function option_definition() {
    $options = parent::option_definition();
    $options['display_format'] = [
      'default' => 'status_label',
    ];

    return $options;
  }

  /**
   * {@inheritdoc}
   */
  public function options_form(&$form, &$form_state) {
    parent::options_form($form, $form_state);

    $form['display_format'] = [
      '#weight' => -10,
      '#type' => 'select',
      '#title' => t('Display format'),
      '#default_value' => $this->options['display_format'],
      '#options' => [
        'status_code' => t('Status code'),
        'status_label' => t('Status label'),
      ],
    ];

    // These fields don't make sense for this data.
    $form['separator']['#access'] = FALSE;
    $form['format_plural']['#access'] = FALSE;
    $form['format_plural_singular']['#access'] = FALSE;
    $form['format_plural_plural']['#access'] = FALSE;
    $form['prefix']['#access'] = FALSE;
    $form['suffix']['#access'] = FALSE;
  }

  /**
   * {@inheritdoc}
   */
  public function render($values) {
    $value = $this->get_value($values);

    if ($this->options['display_format'] == 'status_code') {
      return $value;
    }

    $status = simplytest_tugboat_status_get($value);

    if (!$status) {
      return $value;
    }

    return $status['label'];
  }
}
